Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.pentaho.di.trans.steps.groupby
Class GroupByMeta

    java.lang.Object
      org.pentaho.di.trans.step.BaseStepMeta
          org.pentaho.di.trans.steps.groupby.GroupByMeta

All Implemented Interfaces:
  Cloneable, StepMetaInterface

    public class GroupByMeta

extends BaseStepMeta
implements StepMetaInterface

Created on 02-jun-2003

Field Summary
`static int` | `TYPE_GROUP_AVERAGE`
`static int` | `TYPE_GROUP_CONCAT_COMMA`
`static int` | `TYPE_GROUP_CONCAT_STRING`
`static int` | `TYPE_GROUP_COUNT_ALL`
`static int` | `TYPE_GROUP_CUMULATIVE_AVERAGE`
`static int` | `TYPE_GROUP_CUMULATIVE_SUM`
`static int` | `TYPE_GROUP_FIRST`
`static int` | `TYPE_GROUP_FIRST_INCL_NULL`
`static int` | `TYPE_GROUP_LAST`
`static int` | `TYPE_GROUP_LAST_INCL_NULL`
`static int` | `TYPE_GROUP_MAX`
`static int` | `TYPE_GROUP_MIN`
`static int` | `TYPE_GROUP_NONE`
`static int` | `TYPE_GROUP_STANDARD_DEVIATION`
`static int` | `TYPE_GROUP_SUM`
`static String[]` | `typeGroupCode`
`static String[]` | `typeGroupLongDesc`

Constructor Summary
`GroupByMeta()`

Method Summary
`void` | `allocate(int sizegroup, int nrfields)`
`void` | `check(List<org.pentaho.di.core.CheckResultInterface> remarks, TransMeta transMeta, StepMeta stepMeta, org.pentaho.di.core.row.RowMetaInterface prev, String[] input, String[] output, org.pentaho.di.core.row.RowMetaInterface info)` Checks the settings of this step and puts the findings in a remarks List.
`Object` | `clone()` Make an exact copy of this step, make sure to explicitly copy Collections etc.
`String[]` | `getAggregateField()`
`String` | `getAggregateIgnoredField()`
`int[]` | `getAggregateType()`
`String` | `getDirectory()`
`void` | `getFields(org.pentaho.di.core.row.RowMetaInterface r, String origin, org.pentaho.di.core.row.RowMetaInterface[] info, StepMeta nextStep, org.pentaho.di.core.variables.VariableSpace space)` Get the fields that are emitted by this step
`String[]` | `getGroupField()`
`String` | `getLineNrInGroupField()`
`String` | `getPrefix()`
`StepInterface` | `getStep(StepMeta stepMeta, StepDataInterface stepDataInterface, int cnr, TransMeta transMeta, Trans trans)` Get the executing step, needed by Trans to launch a step.
`StepDataInterface` | `getStepData()` Get a new instance of the appropriate data class.
`String[]` | `getSubjectField()`
`static int` | `getType(String desc)`
`static String` | `getTypeDesc(int i)`
`static String` | `getTypeDescLong(int i)`
`String[]` | `getValueField()`
`String` | `getXML()` Produces the XML string that describes this step's information.
`boolean` | `isAddingLineNrInGroup()`
`boolean` | `isAggregateIgnored()`
`boolean` | `isAlwaysGivingBackOneRow()`
`void` | `loadXML(Node stepnode, List<org.pentaho.di.core.database.DatabaseMeta> databases, Map<String,org.pentaho.di.core.Counter> counters)` Load the values for this step from an XML Node
`boolean` | `passAllRows()`
`void` | `readRep(Repository rep, long id_step, List<org.pentaho.di.core.database.DatabaseMeta> databases, Map<String,org.pentaho.di.core.Counter> counters)` Read the steps information from a Kettle repository
`void` | `saveRep(Repository rep, long id_transformation, long id_step)` Save the steps data into a Kettle repository
`void` | `setAddingLineNrInGroup(boolean addingLineNrInGroup)`
`void` | `setAggregateField(String[] aggregateField)`
`void` | `setAggregateIgnored(boolean aggregateIgnored)`
`void` | `setAggregateIgnoredField(String aggregateIgnoredField)`
`void` | `setAggregateType(int[] aggregateType)`
`void` | `setAlwaysGivingBackOneRow(boolean alwaysGivingBackOneRow)`
`void` | `setDefault()` Set default values
`void` | `setDirectory(String directory)`
`void` | `setGroupField(String[] groupField)`
`void` | `setLineNrInGroupField(String lineNrInGroupField)`
`void` | `setPassAllRows(boolean passAllRows)`
`void` | `setPrefix(String prefix)`
`void` | `setSubjectField(String[] subjectField)`
`void` | `setValueField(String[] valueField)`

Methods inherited from class org.pentaho.di.trans.step.BaseStepMeta
`analyseImpact, cancelQueries, chosesTargetSteps, excludeFromRowLayoutVerification, exportResources, getDialogClassName, getID, getInfoSteps, getRequiredFields, getRequiredFields, getResourceDependencies, getSQLStatements, getTableFields, getTargetSteps, getUsedArguments, getUsedDatabaseConnections, getUsedLibraries, hasChanged, searchInfoAndTargetSteps, setChanged, setChanged, setID, setInfoSteps, setTargetSteps, supportsErrorHandling`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.pentaho.di.trans.step.StepMetaInterface
`analyseImpact, cancelQueries, excludeFromRowLayoutVerification, exportResources, getDialogClassName, getInfoSteps, getRequiredFields, getRequiredFields, getResourceDependencies, getSQLStatements, getTableFields, getTargetSteps, getUsedArguments, getUsedDatabaseConnections, getUsedLibraries, searchInfoAndTargetSteps, setInfoSteps, setTargetSteps, supportsErrorHandling`

Field Detail

### TYPE_GROUP_NONE

    public static final int TYPE_GROUP_NONE

See Also:
  Constant Field Values

### TYPE_GROUP_SUM

    public static final int TYPE_GROUP_SUM

See Also:
  Constant Field Values

### TYPE_GROUP_AVERAGE

    public static final int TYPE_GROUP_AVERAGE

See Also:
  Constant Field Values

### TYPE_GROUP_MIN

    public static final int TYPE_GROUP_MIN

See Also:
  Constant Field Values

### TYPE_GROUP_MAX

    public static final int TYPE_GROUP_MAX

See Also:
  Constant Field Values

### TYPE_GROUP_COUNT_ALL

    public static final int TYPE_GROUP_COUNT_ALL

See Also:
  Constant Field Values

### TYPE_GROUP_CONCAT_COMMA

    public static final int TYPE_GROUP_CONCAT_COMMA

See Also:
  Constant Field Values

### TYPE_GROUP_FIRST

    public static final int TYPE_GROUP_FIRST

See Also:
  Constant Field Values

### TYPE_GROUP_LAST

    public static final int TYPE_GROUP_LAST

See Also:
  Constant Field Values

### TYPE_GROUP_FIRST_INCL_NULL

    public static final int TYPE_GROUP_FIRST_INCL_NULL

See Also:
  Constant Field Values

### TYPE_GROUP_LAST_INCL_NULL

    public static final int TYPE_GROUP_LAST_INCL_NULL

See Also:
  Constant Field Values

### TYPE_GROUP_CUMULATIVE_SUM

    public static final int TYPE_GROUP_CUMULATIVE_SUM

See Also:
  Constant Field Values

### TYPE_GROUP_CUMULATIVE_AVERAGE

    public static final int TYPE_GROUP_CUMULATIVE_AVERAGE

See Also:
  Constant Field Values

### TYPE_GROUP_STANDARD_DEVIATION

    public static final int TYPE_GROUP_STANDARD_DEVIATION

See Also:
  Constant Field Values

### TYPE_GROUP_CONCAT_STRING

    public static final int TYPE_GROUP_CONCAT_STRING

See Also:
  Constant Field Values

### typeGroupCode

    public static final String[] typeGroupCode

### typeGroupLongDesc

    public static final String[] typeGroupLongDesc

Constructor Detail

### GroupByMeta

    public GroupByMeta()

Method Detail

### getAggregateField

    public String[] getAggregateField()

  Returns:
    Returns the aggregateField.

### setAggregateField

    public void setAggregateField(String[] aggregateField)

  Parameters:
    `aggregateField` - The aggregateField to set.

### isAggregateIgnored

    public boolean isAggregateIgnored()

  Returns:
    Returns the aggregateIgnored.

### setAggregateIgnored

    public void setAggregateIgnored(boolean aggregateIgnored)

  Parameters:
    `aggregateIgnored` - The aggregateIgnored to set.

### getAggregateIgnoredField

    public String getAggregateIgnoredField()

  Returns:
    Returns the aggregateIgnoredField.

### setAggregateIgnoredField

    public void setAggregateIgnoredField(String aggregateIgnoredField)

  Parameters:
    `aggregateIgnoredField` - The aggregateIgnoredField to set.

### getAggregateType

    public int[] getAggregateType()

  Returns:
    Returns the aggregateType.

### setAggregateType

    public void setAggregateType(int[] aggregateType)

  Parameters:
    `aggregateType` - The aggregateType to set.

### getGroupField

    public String[] getGroupField()

  Returns:
    Returns the groupField.

### setGroupField

    public void setGroupField(String[] groupField)

  Parameters:
    `groupField` - The groupField to set.

### passAllRows

    public boolean passAllRows()

  Returns:
    Returns the passAllRows.

### setPassAllRows

    public void setPassAllRows(boolean passAllRows)

  Parameters:
    `passAllRows` - The passAllRows to set.

### getSubjectField

    public String[] getSubjectField()

  Returns:
    Returns the subjectField.

### setSubjectField

    public void setSubjectField(String[] subjectField)

  Parameters:
    `subjectField` - The subjectField to set.

### getValueField

    public String[] getValueField()

  Returns:
    Returns the valueField.

### setValueField

    public void setValueField(String[] valueField)

  Parameters:
    `separatorField` - The valueField to set.

### loadXML

    public void loadXML(Node stepnode,
                        List<org.pentaho.di.core.database.DatabaseMeta> databases,
                        Map<String,org.pentaho.di.core.Counter> counters)
                 throws org.pentaho.di.core.exception.KettleXMLException

  Description copied from interface: `StepMetaInterface`
  Load the values for this step from an XML Node

  Specified by:
    `loadXML` in interface `StepMetaInterface`
  Parameters:
    `stepnode` - the Node to get the info from
    `databases` - The available list of databases to reference to
    `counters` - Counters to reference.
  Throws:
    `org.pentaho.di.core.exception.KettleXMLException` - When an unexpected XML error occurred. (malformed etc.)

### allocate

    public void allocate(int sizegroup,
                         int nrfields)

### clone

    public Object clone()

  Description copied from interface: `StepMetaInterface`
  Make an exact copy of this step, make sure to explicitly copy Collections etc.

  Specified by:
    `clone` in interface `StepMetaInterface`
  Overrides:
    `clone` in class `BaseStepMeta`
  Returns:
    an exact copy of this step

### getType

    public static final int getType(String desc)

### getTypeDesc

    public static final String getTypeDesc(int i)

### getTypeDescLong

    public static final String getTypeDescLong(int i)

### setDefault

    public void setDefault()

  Description copied from interface: `StepMetaInterface`
  Set default values

  Specified by:
    `setDefault` in interface `StepMetaInterface`

### getFields

    public void getFields(org.pentaho.di.core.row.RowMetaInterface r,
                          String origin,
                          org.pentaho.di.core.row.RowMetaInterface[] info,
                          StepMeta nextStep,
                          org.pentaho.di.core.variables.VariableSpace space)

  Description copied from interface: `StepMetaInterface`
  Get the fields that are emitted by this step

  Specified by:
    `getFields` in interface `StepMetaInterface`
  Overrides:
    `getFields` in class `BaseStepMeta`
  Parameters:
    `r` - The fields that are entering the step. These are changed to reflect the output metadata.
    `origin` - The name of the step to be used as origin
    `info` - The input rows metadata that enters the step through the specified channels in the same order as in method getInfoSteps(). The step metadata can then choose what to do with it: ignore it or not. Interesting is also that in case of database lookups, the layout of the target database table is put in info[0]
    `nextStep` - if this is a non-null value, it's the next step in the transformation. The one who's asking, the step where the data is targetted towards.
    `space` - TODO

### getXML

    public String getXML()

  Description copied from class: `BaseStepMeta`
  Produces the XML string that describes this step's information.

  Specified by:
    `getXML` in interface `StepMetaInterface`
  Overrides:
    `getXML` in class `BaseStepMeta`
  Returns:
    String containing the XML describing this step.

### readRep

    public void readRep(Repository rep,
                        long id_step,
                        List<org.pentaho.di.core.database.DatabaseMeta> databases,
                        Map<String,org.pentaho.di.core.Counter> counters)
                 throws org.pentaho.di.core.exception.KettleException

  Description copied from interface: `StepMetaInterface`
  Read the steps information from a Kettle repository

  Specified by:
    `readRep` in interface `StepMetaInterface`
  Parameters:
    `rep` - The repository to read from
    `id_step` - The step ID
    `databases` - The databases to reference
    `counters` - The counters to reference
  Throws:
    `org.pentaho.di.core.exception.KettleException` - When an unexpected error occurred (database, network, etc)

### saveRep

    public void saveRep(Repository rep,
                        long id_transformation,
                        long id_step)
                 throws org.pentaho.di.core.exception.KettleException

  Description copied from interface: `StepMetaInterface`
  Save the steps data into a Kettle repository

  Specified by:
    `saveRep` in interface `StepMetaInterface`
  Parameters:
    `rep` - The Kettle repository to save to
    `id_transformation` - The transformation ID
    `id_step` - The step ID
  Throws:
    `org.pentaho.di.core.exception.KettleException` - When an unexpected error occurred (database, network, etc)

### check

    public void check(List<org.pentaho.di.core.CheckResultInterface> remarks,
                      TransMeta transMeta,
                      StepMeta stepMeta,
                      org.pentaho.di.core.row.RowMetaInterface prev,
                      String[] input,
                      String[] output,
                      org.pentaho.di.core.row.RowMetaInterface info)

  Description copied from interface: `StepMetaInterface`
  Checks the settings of this step and puts the findings in a remarks List.

  Specified by:
    `check` in interface `StepMetaInterface`
  Parameters:
    `remarks` - The list to put the remarks in @see org.pentaho.di.core.CheckResult
    `stepMeta` - The stepMeta to help checking
    `prev` - The fields coming from the previous step
    `input` - The input step names
    `output` - The output step names
    `info` - The fields that are used as information by the step

### getStep

    public StepInterface getStep(StepMeta stepMeta,
                                 StepDataInterface stepDataInterface,
                                 int cnr,
                                 TransMeta transMeta,
                                 Trans trans)

  Description copied from interface: `StepMetaInterface`
  Get the executing step, needed by Trans to launch a step.

  Specified by:
    `getStep` in interface `StepMetaInterface`
  Parameters:
    `stepMeta` - The step info
    `stepDataInterface` - the step data interface linked to this step. Here the step can store temporary data, database connections, etc.
    `cnr` - The copy nr to get
    `transMeta` - The transformation info
    `trans` - The launching transformation

### getStepData

    public StepDataInterface getStepData()

  Description copied from interface: `StepMetaInterface`
  Get a new instance of the appropriate data class. This data class implements the StepDataInterface. It basically contains the persisting data that needs to live on, even if a worker thread is terminated.

  Specified by:
    `getStepData` in interface `StepMetaInterface`
  Returns:
    The appropriate StepDataInterface class.

### getDirectory

    public String getDirectory()

  Returns:
    Returns the directory.

### setDirectory

    public void setDirectory(String directory)

  Parameters:
    `directory` - The directory to set.

### getPrefix

    public String getPrefix()

  Returns:
    Returns the prefix.

### setPrefix

    public void setPrefix(String prefix)

  Parameters:
    `prefix` - The prefix to set.

### isAddingLineNrInGroup

    public boolean isAddingLineNrInGroup()

  Returns:
    the addingLineNrInGroup

### setAddingLineNrInGroup

    public void setAddingLineNrInGroup(boolean addingLineNrInGroup)

  Parameters:
    `addingLineNrInGroup` - the addingLineNrInGroup to set

### getLineNrInGroupField

    public String getLineNrInGroupField()

  Returns:
    the lineNrInGroupField

### setLineNrInGroupField

    public void setLineNrInGroupField(String lineNrInGroupField)

  Parameters:
    `lineNrInGroupField` - the lineNrInGroupField to set

### isAlwaysGivingBackOneRow

    public boolean isAlwaysGivingBackOneRow()

  Returns:
    the alwaysGivingBackOneRow

### setAlwaysGivingBackOneRow

    public void setAlwaysGivingBackOneRow(boolean alwaysGivingBackOneRow)

  Parameters:
    `alwaysGivingBackOneRow` - the alwaysGivingBackOneRow to set

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD